#!/usr/bin/perl
use strict;
use warnings;
use Math::MPFI qw(:mpfi);

Rmpfi_set_default_prec(16);            # Set default precision to 16 bits

sub format_epsilon{
  my $x = $_[0];
  
  my $m = Math::MPFR->new();
  Rmpfi_mid($m, $x);
  
  my $y = Math::MPFI->new();
  Rmpfi_sub_fr($y, $x, $m);
  
  my $epsilon = Math::MPFR->new();
  Rmpfi_mag($epsilon, $y);
  
  return "$m +/- $epsilon";
}

for ('[1,9]', '[-1,5]', '[-5,-1]', '[0.025,0.032]', '1.1') {
  my $z = Math::MPFI->new($_);
  print "$z = ",format_epsilon($z),"\n";
}
