#!/usr/bin/perl
use strict;
use warnings;
use Math::MPFI qw(:mpfi);

sub format_epsilon{
  my $x = $_[0];
  
  my $m = Math::MPFR->new();
  Rmpfi_mid($m, $x);
  
  my $y = Math::MPFI->new();
  Rmpfi_sub_fr($y, $x, $m);
  
  my $epsilon = Math::MPFR->new();
  Rmpfi_mag($epsilon, $y);
  
  return "$m +/- $epsilon";
}

my $pi = Math::MPFI->new();
Rmpfi_const_pi($pi);

my $a = 60 + Math::MPFI->new('[-0.5,0.5]');
$a *= $pi/180;

my $d = 45 + Math::MPFI->new('[-0.5,0.5]');
$d *= $pi/180;

my $n = sin(($d+$a)/2)/sin($a/2);

print "n = $n\n";
print "or n = ", format_epsilon($n), "\n";
